/* Copyright (c) 2012 Jesper Öqvist <jesper@llbit.se>
 *
 * This file is part of Chunky.
 *
 * Chunky is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Chunky is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with Chunky.  If not, see <http://www.gnu.org/licenses/>.
 */
package se.llbit.chunky.main;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.BufferStrategy;

@SuppressWarnings("serial")
public class Canvas3D extends Canvas {
	
    private BufferStrategy strategy;

    public Canvas3D() {
        setBackground(Color.white);
        setPreferredSize(new Dimension(400, 400));
        setMinimumSize(new Dimension(100, 100));
        setIgnoreRepaint(true);
    }
    
    public void init() {
        createBufferStrategy(2);
        strategy = getBufferStrategy();
    }

	@Override
    public Graphics getGraphics() {
		return strategy.getDrawGraphics();
	}
	
	public synchronized void update() {
		if (isDisplayable()) {
            strategy.show();
        }
	}
	
}
