/* Copyright (c) 2012 Jesper Öqvist <jesper@llbit.se>
 *
 * This file is part of Chunky.
 *
 * Chunky is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Chunky is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with Chunky.  If not, see <http://www.gnu.org/licenses/>.
 */
package se.llbit.chunky.world;

public class Biomes {
	private static final int[] grassColor = {
			0x75B646,// ocean
			0x8DB84A,// plains
			0x9BA863,// desert
			0x75B646,// extreme hills
			0x4A8F3A,// forest
			0x478852,// taiga
			0x3e5226,// swampland
			0x75B646,// river
			0x75B646,// hell
			0x75B646,// sky
			0x7A9C91,// frozen ocean
			0x7A9C91,// frozen river
			0x7A9C91,// ice plains
			0x7A9C91,// ice mountains
			0x939D88,// mushroom island
			0x939D88,// mushroom island shore
			0x75B646,// beach
			0x9BA863,// desert hills
			0x4A8F3A,// forest hills
			0x478852,// taiga hills
			0x75B646,// extreme hills edge
			0x3A8B25,// jungle
			0x3A8B25,// jungle hills
	};
	private static final int UNKNOWN_COLOR = 0x7E7E7E;
	public static boolean biomeColorsEnabled = true;
	
	public static final int getColor(int biomeId) {
		if (!biomeColorsEnabled)
			return grassColor[0];
		if (biomeId > grassColor.length)
			return UNKNOWN_COLOR;
		return grassColor[biomeId];
	}
}
