/* Copyright (c) 2010-2012 Jesper Öqvist <jesper@llbit.se>
 *
 * This file is part of Chunky.
 *
 * Chunky is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Chunky is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with Chunky.  If not, see <http://www.gnu.org/licenses/>.
 */
package se.llbit.chunky.world;

/**
 * ChunkParser parses chunks after they have been read from
 * the filesystem by WorldLoader.
 * 
 * @author Jesper Öqvist (jesper@llbit.se)
 */
public class ChunkParser extends Thread {
	
	private int dimension;
	@SuppressWarnings("unused")
	private int layer;
	private Heightmap heightmap;
	private World world;

	public ChunkParser(World world) {
	    super("Chunk Parser");
		this.world = world;
		dimension = world.currentDimension();
		heightmap = world.heightmap();// FIXME
	}

	public void run() {
		try {
			while (!isInterrupted()) {
				Chunk chunk = world.getNextFromParseQueue();
				chunk.parse(world.getDataDirectory(), dimension, world.currentLayer(), heightmap);
				world.doneParsing(chunk);
			}
		} catch (InterruptedException e) {
		}
	}

}
