package se.llbit.util;

import se.llbit.math.Vector3d;

public class VectorPool {
    private int limit = 10;
    private int size = 0;
    private Vector3d[] pool = new Vector3d[limit];
    
    public final Vector3d get(Vector3d other) {
        Vector3d vec;
        if (size == 0) {
            vec = new Vector3d();
        } else {
            vec = pool[--size];
        }
        vec.set(other);
        return vec;
    }
    
    public final Vector3d get(double x, double y, double z) {
        Vector3d vec;
        if (size == 0) {
            vec = new Vector3d();
        } else {
            vec = pool[--size];
        }
        vec.set(x, y, z);
        return vec;
    }
    
    public final Vector3d get() {
        if (size == 0) {
            Vector3d vec = new Vector3d();
            return vec;
        } else {
            return pool[--size];
        }
    }
    
    public final void dispose(Vector3d vec) {
        if (size == limit) {
            int newLimit = limit * 2;
            Vector3d[] newPool = new Vector3d[newLimit];
            System.arraycopy(pool, 0, newPool, 0, limit);
            limit = newLimit;
            pool = newPool;
        }
        pool[size++] = vec;
    }
}
